<?php

namespace TYPO3\T3extblog\Controller;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2012-2013 Felix Kopp <felix-source@phorax.com>
 *  (c) 2013-2015 Felix Nagel <info@felixnagel.com>
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

use TYPO3\T3extblog\Domain\Model\Post;

/**
 * BackendCommentController
 */
class BackendCommentController extends BackendBaseController {

	/**
	 * Displays all comments
	 *
	 * @return void
	 */
	public function indexAction() {
		$this->view->assign('comments', $this->commentRepository->findByPage($this->pageId));
		$this->view->assign('pendingComments', $this->commentRepository->findPendingByPage($this->pageId));
	}

	/**
	 * Displays all pending comments
	 *
	 * @return void
	 */
	public function listPendingAction() {
		$this->view->assign('pendingComments', $this->commentRepository->findPendingByPage($this->pageId));
	}

	/**
	 * Displays all comments for a post
	 *
	 * @param Post $post The post
	 *
	 * @return void
	 */
	public function listByPostAction(Post $post) {
		$this->view->assignMultiple(array(
			'post' => $this->postRepository->findOneByUid($post),
			'comments' => $this->commentRepository->findByPost($post, FALSE),
			'pendingComments' => $this->commentRepository->findPendingByPost($post)
		));
	}

}
